package de.zkm.kafka.connect.transforms;

import org.apache.kafka.common.config.ConfigDef;
import org.apache.kafka.connect.connector.ConnectRecord;
import org.apache.kafka.connect.data.Schema;
import org.apache.kafka.connect.transforms.Transformation;
import org.apache.kafka.connect.data.SchemaBuilder;
import java.util.Map;


/**
 * This transform does not work as expected, see the README.md for further information.
 */
@Deprecated
public class AddAdditionalPropertiesTransform<R extends ConnectRecord<R>> implements Transformation<R> {
    
    @Override
    public R apply(R record) {
        if (record.valueSchema() == null) {
            return record;
        }
        
        // Create a modified schema with additionalProperties
        Schema modifiedSchema = modifySchema(record.valueSchema());
        
        // Return a new record with the modified schema
        return record.newRecord(
            record.topic(),
            record.kafkaPartition(),
            record.keySchema(),
            record.key(),
            modifiedSchema,
            record.value(),
            record.timestamp()
        );
    }
    
    private Schema modifySchema(Schema schema) {
        // This is where you'd add the logic to modify the JSON schema
        // For JSON Schema in Kafka Connect, you'd need to access
        // and modify the underlying schema parameters
        
        // This is a simplified example - you'd need to handle all schema types
        SchemaBuilder builder = SchemaBuilder.struct();
        
        // Copy all fields from the original schema
        for (org.apache.kafka.connect.data.Field field : schema.fields()) {
            builder.field(field.name(), field.schema());
        }
        
        // Add the additionalProperties parameter to schema parameters
        Map<String, String> parameters = schema.parameters();
        if (parameters != null) {
            parameters.put("additionalProperties", "true");
        }
        
        // Add all parameters to the new schema
        if (parameters != null) {
            for (Map.Entry<String, String> param : parameters.entrySet()) {
                builder.parameter(param.getKey(), param.getValue().toString());
            }
        }
        
        return builder.build();
    }
    
    @Override
    public ConfigDef config() {
        return new ConfigDef();
    }
    
    @Override
    public void close() {
        // No resources to close
    }
    
    @Override
    public void configure(Map<String, ?> configs) {
        // No configuration needed
    }
}
